{
    main.pas

	This file is a part of
	
    EasySlideShowMaker v. 1.41  -  A easy GNU slide show maker.
    Copyright (C) 2010  Patrick Eigensatz

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY;
   
    without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License (added as "License.txt") for
    more information.
}

unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtDlgs, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button6:  TButton;
    Button3:  TButton;
    Button5:  TButton;
    Button1:  TButton;
    Button4:  TButton;
    Button2:  TButton;
    Button7:  TButton;
    Button8:  TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ColorDialog1: TColorDialog;
    Edit1:    TEdit;
    Label1:   TLabel;
    Label2:   TLabel;
    Label3:   TLabel;
    Label4: TLabel;
    Listbox1: TListbox;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel1:   TPanel;
    Panel2: TPanel;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  projectfolder, ext, filename, path, exepath: string;
  sl2, slength, x: integer;
  sp:    TMemoryStream;
  Config, Exten, Captions, lang, programconfig: TStringList;
  bgc, lmaximg, limg, fc: integer;

implementation


uses
  viewer, settingsdialog, howto, about;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  lang     := TStringList.Create;
  config   := TStringList.Create;
  Exten    := TStringList.Create;
  Captions := TStringList.Create;
  programconfig := TStringList.Create;
  exepath := ExtractFilePath(Application.ExeName);     //PATCH: Get path!
  programconfig.LoadFromFile(exepath + 'config.ini');
  lang.LoadFromFile(exepath + programconfig.Strings[0]);

  // Get settings!
  Button5.Caption   := lang.Strings[0];
  Button4.Caption   := lang.Strings[1];
  Checkbox1.Caption := lang.Strings[2];
  Label1.Caption    := lang.Strings[3];
  Button3.Caption   := lang.Strings[5];
  Button2.Caption   := lang.Strings[7];
  Button6.Caption   := lang.Strings[6];
  Button1.Caption   := lang.Strings[4];
  Label2.Caption    := lang.Strings[24];
  Button7.Caption   := lang.Strings[27];
  Button8.Caption   := lang.Strings[29];
  Checkbox2.Caption := lang.Strings[32];
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  try
    filename := Listbox1.Items.Strings[Listbox1.ItemIndex];
    Viewer.iviewer.Label1.Caption := Captions.Strings[Listbox1.ItemIndex];

    Viewer.iviewer.Image1.Picture.LoadFromFile(filename);

{* If Label bigger than the picture, !respect the label!
   Else: !respect the picture!
   In such way, the  xform can itself extend so that the picture and the label in the form have place.
   The form becomes still 100 pixels more, than the picture (and/or the label).
  *}

    if viewer.iviewer.Label1.Width > iviewer.Image1.Picture.Width then
    begin
      x := iviewer.Label1.Width - iviewer.Image1.Picture.Width;
      viewer.iviewer.Width := 0;    // Reset first
      viewer.iviewer.Width := iviewer.Image1.Picture.Width + x + 50;
    end;

    // Else
    if viewer.iviewer.Image1.Picture.Width > iviewer.Label1.Width then
    begin
      x := iviewer.Image1.Picture.Width - iviewer.Label1.Width;
      viewer.iviewer.Width := 0;    // Reset first
      viewer.iviewer.Width := iviewer.Label1.Width + x + 50;
    end;

    viewer.iviewer.Height := iviewer.Image1.Picture.Height + 75; {still 25 pixels more at the
                                                              downside and 50 pixels more
                                                              at the upside!}
    // Now, show the picture!
    viewer.iviewer.Show;


  except
    ShowMessage('Error by loading file: ' + filename);
  end;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
  Colordialog1.Color := bgc;

  Colordialog1.Execute;
  bgc := Colordialog1.Color;
  Panel1.Color := bgc;
  Label3.Caption := 'Dec: ' + IntToStr(bgc);
end;

procedure TForm1.Panel2Click(Sender: TObject);
begin
  Colordialog1.Color := fc;

  Colordialog1.Execute;
  fc := Colordialog1.Color;
  Panel2.Color := fc;
  Label4.Caption := 'Dec: ' + IntToStr(fc);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  try
    OpenPictureDialog1.Execute;
    filename := OpenPictureDialog1.FileName;

    // Get Extension!
    slength := Length(filename);
    ext     := filename[slength - 2];
    ext     := ext + filename[slength - 1];
    ext     := ext + filename[slength];

    Listbox1.Items.Add(filename);
    Captions.Add(Inputbox(lang.Strings[8], lang.Strings[9], ''));
    Exten.Add(ext);

    iviewer.Label1.Caption := Captions.Strings[Captions.Count - 1];
    viewer.iviewer.Image1.Picture.LoadFromFile(filename);

{* If Label bigger than the picture, !respect the label!
   Else: !respect the picture!
   In such way, the xform can itself extend so that the picture and the label in the form have place.
   The form becomes still 50 pixels more, than the picture (and/or the label).
  *}

    if viewer.iviewer.Label1.Width > iviewer.Image1.Picture.Width then
    begin
      x := iviewer.Label1.Width - iviewer.Image1.Picture.Width;
      viewer.iviewer.Width := 0;    // Reset first
      viewer.iviewer.Width := iviewer.Image1.Picture.Width + x + 50;
    end;

    // Else
    if viewer.iviewer.Image1.Picture.Width > iviewer.Label1.Width then
    begin
      x := iviewer.Image1.Picture.Width - iviewer.Label1.Width;
      viewer.iviewer.Width := 0;    // Reset first
      viewer.iviewer.Width := iviewer.Label1.Width + x + 50;
    end;

    viewer.iviewer.Height := iviewer.Image1.Picture.Height + 75; {still 25 pixels more at the
                                                       downside and 50 pixels more
                                                       at the upside!}
    // Now, show the picture!
    viewer.iviewer.Show;

    // Save it !
    // Count - 1 because the images begins at 0!
    viewer.iviewer.Image1.Picture.SaveToFile(projectfolder +
      IntToStr(Listbox1.Count - 1) + '.' + ext);

  except
    Form1.Color := cllime;  // No error by Abort!
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  config.Clear;
  config.Add(IntToStr(Listbox1.Count));

  // Fullscreen?
  if Checkbox1.Checked then
    config.Add('fs')
  else
    config.Add('false');

  // Title of the window!
  if Checkbox1.Checked then
    config.Add('slideshow')
  else
    config.Add(Edit1.Text);

  // Background color!
  bgc := Panel1.Color;
  config.Add(IntToStr(bgc));

  If not Checkbox2.Checked then config.Add('false') else config.Add('true');

  config.Add(IntToStr(fc));

  // Get the execute path of essm to copy slideshow.exe!
  sl2  := Length(Application.ExeName);
  path := Application.ExeName;

  // Save informations in the files!
  config.SaveToFile(projectfolder + 'slideshow.ini');
  Exten.SaveToFile(projectfolder + 'ext.ini');
  Captions.SaveToFile(projectfolder + 'cap.ini');

  // Now "cut" the slideshowmaker.exe away!
  SetLength(path, Length(path) - 18);


  sp := TMemoryStream.Create;
  sp.LoadFromFile(path + 'slideshow.exe');
  sp.SaveToFile(projectfolder + 'slideshow.exe');
  ShowMessage(lang.Strings[13]);
  ShowMessage(lang.Strings[14]);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  about.aboutform.Show;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  howto.note.Show;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Checkbox2.Checked := True;
  Button4.Visible := True;
  Button8.Visible := True;
  Listbox1.Items.Clear;
  Exten.Clear;
  Captions.Clear;
  config.Clear;
  Panel1.Color   := cllime;
  Panel2.Color   := clblack;
  ColorDialog1.Color := cllime;
  Label3.Caption := 'Dec. 65280';
  bgc := 65280;
  fc := 0;
  Label4.Caption := 'Dec. 0';

  // First reset variables!
  projectfolder := '';
  filename      := '';

  viewer.iviewer.Hide;
  SelectDirectoryDialog1.Execute;
  projectfolder := SelectDirectoryDialog1.FileName + '\';
  If projectfolder = '' then Button5.Click;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  settingsdialog.Settings.Show;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  try
  Checkbox2.Checked := True;
  Button4.Visible := True;
  Button8.Visible := True;
  Listbox1.Items.Clear;
  Exten.Clear;
  Captions.Clear;
  config.Clear;
  Panel1.Color   := cllime;
  Panel2.Color   := clblack;
  ColorDialog1.Color := cllime;
  Label3.Caption := 'Dec. 65280';
  bgc := 65280;
  fc := 0;
  Label4.Caption := 'Dec. 0';

  // First reset variables!
  projectfolder := '';
  filename      := '';


    viewer.iviewer.Hide;
    ShowMessage(lang.Strings[28]);
    SelectDirectoryDialog1.Execute;
    projectfolder := SelectDirectoryDialog1.FileName + '\';

    // Load slideshow configuration!
    config.LoadFromFile(projectfolder + 'slideshow.ini');
    Exten.LoadFromFile(projectfolder + 'ext.ini');
    Captions.LoadFromFile(projectfolder + 'cap.ini');
    lmaximg := StrToInt(config.Strings[0]) - 1; { -1 because the property Count is always + 1!
                                               and maximg doesn't existing!}
    for limg := 0 to lmaximg do
    begin
      Listbox1.Items.Add(projectfolder + IntToStr(limg) + '.' + Exten.Strings[limg]);
    end;


    If config.Strings[1] = 'fs' then Checkbox1.Checked := True else Edit1.Text := config.Strings[2];


    Panel1.Color := StrToInt(config.Strings[3]);
    Label3.Caption  := 'Dec. ' + config.Strings[3];
    Button8.Visible := True;

    If config.Strings[4]= 'false' then Checkbox2.Checked := false;

    bgc := StrToInt(config.Strings[3]);
    fc := StrToInt(config.Strings[5]);

    Panel2.Color := StrToInt(config.Strings[5]);
    Label4.Caption  := 'Dec. ' + config.Strings[5];

  except
    ShowMessage(lang.Strings[31]);
    Button8.Visible := False;  // Save function is not possible, if there was an error.
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  try
{The save procedure is the same like
 the build procedure but the slideshow.exe
 will not be copied! }

    config.Clear;
    config.Add(IntToStr(Listbox1.Count));

    // Fullscreen?
    if Checkbox1.Checked then
      config.Add('fs')
    else
      config.Add('false');

    // Title of the window!
    if Checkbox1.Checked then
      config.Add('slideshow')
    else
      config.Add(Edit1.Text);

    // Background color!
    bgc := Panel1.Color;
    config.Add(IntToStr(bgc));

    If not Checkbox2.Checked then config.Add('false') else config.Add('true');  // Show 1/5.

    config.Add(IntToStr(fc));

    // Save informations in the files!
    config.SaveToFile(projectfolder + 'slideshow.ini');
    Exten.SaveToFile(projectfolder + 'ext.ini');
    Captions.SaveToFile(projectfolder + 'cap.ini');
  except
    ShowMessage(lang.Strings[30]);
  end;
end;

initialization
  {$I main.lrs}

end.

